// Tunables
//var newtonGravity=.75;    // some gravity
var shipsmass=50;           // some mass for the ships
var ballmass=10;            // some mass for the energy sphere
var ballspeed=50;          // some speed for the energy sphere (was 5000)
var thruster_factor=2.5;
var start_x=0;    // x, y, z start position of the energy_sphere
var start_y=0;
var start_z=0;

define _mass,skill1;
define _lineardrag,skill2;
define _angulardragx,skill3;
define _angulardragy,skill4;
define _angulardragz,skill5;
define _shapefactor,skill6;
define _material,skill7;
define _waterentity,skill8;

define _collisionshape,flag1;
define _autorest,flag2;
define _startactive,flag3;

function* p_phevent;
entity* p_tempent1;
entity* p_tempent2;

sound snd_click=<click.wav>;
sound snd_poolball=<poolball.wav>;
sound door_op=<door_op.wav>;

var ground_material;
var wood_material;
var ivory_material;
var water_material;

define newtonGravity,-0.1;  // we need a slight amount of gravity to make the launch_pads stick to the ship
//define newtonGravity,0.0;  // we need a slight amount of gravity to make the launch_pads stick to the ship

define MAX_VALUE,1048576.0;

define SOUND_IMPACT_DELAY,8;
define MIN_IMPACT_SPEED, 0.25;
define MAX_LANDING_SPEED, 3.0;
var maxCollisionSpeed;
var current_speed;

/***************************************************************************
Function to cause a sphere explosion
***************************************************************************/

function sphere_explode() // your function name.
{
	MY.PASSABLE = ON; // passable pieces

	MY.SCALE_X *= (3); // scale x y and z going down.
	MY.SCALE_Y *= (3);
	MY.SCALE_Z *= (3);

	MY.FLARE = ON; // making it very bright like a glow
	MY.LIGHT = ON; // bright
	MY.BRIGHT = ON; // giving more light
	//	MY.BLEND = ON; // blend into everything else.

	MY.LIGHTRED =  255; // very red for fire 255 bright 0 black
	MY.LIGHTGREEN = 0; // medium blue was 150
	MY.LIGHTBLUE = 255; // no blue
	MY.LIGHTRANGE = 100; // raneg of 100 chnage to distance of shot.


	temp.PAN = 360;
	temp.TILT = 360;
	temp.Z =  105; //105 Unit exploding range
	//indicator = jet_EXPLODE;
	//c_scan (MY.POS,MY_ANGLE,temp);

	//temp = 10000;
	//PLAY_ENTSOUND ME,amplified_template_explosion,temp; // play sound from the main 		//defines.

	MY.FRAME = 1;
	WHILE(MY.FRAME<=16)
	{
		MY.LIGHTRANGE += 2;
		MY.FRAME+=TIME;
		MY.Z += 6*TIME;
		wait(1);
	}

	MY.INVISIBLE = ON; // turning the pieces off and all of the explode.
	my.passable = on; // so we don't crash into the invisible pieces
	WHILE(MY.LIGHTRANGE > 0)
	{
		MY.LIGHTRANGE -= 5; // turning the range down.
		
		wait(1);
	} 
	my.passable = off;
	ent_remove (me); // remove all of the function.
}


//-------------------------------------------------------------------------------------------------gravity_event
function gravity_event(body) 
{
	var mass;
	mass=NewtonGetBodyMass(body);
	NewtonBodyAddForce(body,0,0,mass*newtonGravity);

	if(my._waterentity!=0) // in water
	{
		ApplyBuoyancy(body);
	}
}

//-------------------------------------------------------------------------------------------------collisionbegin_event
function collisionbegin_event(material) 
{

	maxCollisionSpeed=0;
	current_speed = 0;
	return (1);
}

//-------------------------------------------------------------------------------------------------collisioncontact_event
function collisioncontact_event(material,contact) 
{
	var speed;

	speed=NewtonMaterialGetNormalSpeed(material,contact);
	current_speed = speed;
	
	if(speed>maxCollisionSpeed)
	{
		maxCollisionSpeed=speed; 
	}

}

sound wham = <wham.wav>;
sound explosion = <explo.wav>;

//-------------------------------------------------------------------------------------------------collisionend_event
function collisionend_event(material) 
{

	var volume;
	var error;	
	//	var first_impact = 0;
	

	//	if (!ship_landed){
		//		display5 = maxCollisionSpeed;	
		//		display6 = current_speed;
	//	}

	if(maxCollisionSpeed>MIN_IMPACT_SPEED) {
		error=(maxCollisionSpeed-MIN_IMPACT_SPEED);
		volume=10+error*error*5;//*0.05;
		clamp (volume,40,1000);
		ent_playsound (me, wham,volume); 
		
		/**************************************************************************
		This code handle contact with any of the stationary ships
		Contact with an Ore_hauler costs you the game in multiplayer, or
		single player when the pad number is 1-6
		***************************************************************************/
		if(pad_no < 8) {
			if((my.ENTITY_TYPE == SHIP_TYPE) && (my.ENTITY_STATUS != LOSER) && (you.ENTITY_TYPE == ORE_HAULER))
			{
				my.ENTITY_STATUS = LOSER;
			
				if (connection) {
					mp_loser_ships +=1;
					send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
				}
				time_display_running = 0;    // turn off the timer
				if (!connection) {
					ship_landed = 2;             // show that we have landed on the appropriate pad
				}	
				//ship_landed = 2;             // show that we have crashed
				time_display_running = 0;       // turn off the timer	
			}
			
			if  ((you.ENTITY_TYPE == SHIP_TYPE) && (you.ENTITY_STATUS != LOSER) && (my.ENTITY_TYPE == ORE_HAULER))			    
			{
				you.ENTITY_STATUS = LOSER;
				if (connection) {
					mp_loser_ships +=1;
					send_skill(you.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
				}			
				if (!connection) {
					ship_landed = 2;             // show that we have landed on the appropriate pad
				}	
				time_display_running = 0;       // turn off the timer
			}
			
		}


		/*********************************************************************************************
		* This code handles the Landing Pad activity                                                 *
		* If the ship making contact is active and it's speed is below the maximum then it 'owns'    *
		* the pad. 
		**********************************************************************************************/
		if (maxCollisionSpeed<MAX_LANDING_SPEED) {
			
			if  ((my.ENTITY_TYPE == SHIP_TYPE) && (my.ENTITY_STATUS == ACTIVE) 
			&& (you.ENTITY_TYPE == LANDING_PAD_TYPE))		    
			{
				my.ENTITY_STATUS = PAD_OWNER;     // This ship owns the pad
				if (connection) {
					my.ENTITY_STATUS = PAD_OWNER_MP;
					send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
				}
				
				time_display_running = 0;        // turn off the timer
				if (!connection) {               // for single player we need to show that we landed
					ship_landed = 1;
					mp_no_physics = 1;           // prevent any further physics 
					NewtonRemoveEntity(my);  // release this ship from the physics engine
					
				}				
				// The following is to handle multiplayer 
				
				// if no one owns the pad, then we are the 'previous owner' - see mulitplayer_monitor()
				if (mp_prev_pad_owner == 0) {
					mp_prev_pad_owner = my.SHIP_NUM;
				}
				
				// save the ship number and handle
				mp_pad_owner = my.SHIP_NUM;  
				mp_pad_owner_handle = handle(my);
				
			}
			
			if ((you.ENTITY_TYPE == SHIP_TYPE) && (you.ENTITY_STATUS == ACTIVE) 
			&& (my.ENTITY_TYPE == LANDING_PAD_TYPE))
			{
				you.ENTITY_STATUS = PAD_OWNER;
				if (connection) {
					you.ENTITY_STATUS = PAD_OWNER_MP;
					send_skill(you.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
				}
				time_display_running = 0;    // turn off the timer
				if (!connection) {
					ship_landed = 1;             // show that we have landed on the appropriate pad
					mp_no_physics = 1;           // prevent any further physics
					NewtonRemoveEntity(you);     // release this ship from the physics engine

				}
				
				/*************************************
				The following is to handle multiplayer 
				**************************************/
				// for multiplayer if no one owns the pad, then we are the 'previous owner' as well as the owner
				if (mp_prev_pad_owner == 0) {
					mp_prev_pad_owner = my.SHIP_NUM;
				}
				
				// for multiplayer, save the landing ship number and handle
				mp_pad_owner = you.SHIP_NUM;  
				mp_pad_owner_handle = handle(you);
			}
			
		}
		
	}
	
	
}



//-------------------------------------------------------------------------------------------------water_event
function water_event(watermaterial)
{
	my._waterentity=you;	
	you._waterentity=my;
	return(0); // return zero to indicate that contacts should not be processed
} 

//-------------------------------------------------------------------------------------------------newtonsetupsystem
function NewtonSetupSystem() 
{
	dll_handle = newtonHandle;
	NewtonSetUnitSystem(QUANT_IS_INCH);
	ground_material=0; // the ground material is the standard material
	NewtonMaterialSetFriction(			ground_material, ground_material, 1.0, 0.8);
	NewtonMaterialSetElasticity(		ground_material, ground_material, 0.4);
	NewtonMaterialSetDepthRecover(	ground_material, ground_material, 0.2);
	NewtonMaterialSetSoundEffect(		ground_material, ground_material, snd_click);
	NewtonMaterialSetCollisionEnd(	ground_material, ground_material, collisionend_event);	
	NewtonMaterialCollisionBegin(		ground_material, ground_material, collisionbegin_event);
	NewtonMaterialCollisionContact(	ground_material, ground_material, collisioncontact_event);

	// the other materials have to be created
	wood_material=NewtonCreateMaterial();
	ivory_material=NewtonCreateMaterial();
	water_material=NewtonCreateMaterial();

	// set material interaction propeteries
	NewtonMaterialSetFriction(			wood_material, ground_material, 1.0, 0.7);
	NewtonMaterialSetElasticity(		wood_material, ground_material, 0.4);
	NewtonMaterialSetDepthRecover(	wood_material, ground_material, 0.2);
	NewtonMaterialSetSoundEffect(		wood_material, ground_material, snd_click);
	
	NewtonMaterialSetFriction(			wood_material, wood_material, 1.0, 1.0);
	NewtonMaterialSetElasticity(		wood_material, wood_material, 0.1);
	NewtonMaterialSetDepthRecover(	wood_material, wood_material, 0.2);
	NewtonMaterialSetSoundEffect(		wood_material, wood_material, snd_click);

	NewtonMaterialSetFriction(			ivory_material, wood_material, 1.0, 0.9);
	NewtonMaterialSetElasticity(		ivory_material, wood_material, 0.7);
	NewtonMaterialSetDepthRecover(	ivory_material, wood_material, 0.2);
	NewtonMaterialSetSoundEffect(		ivory_material, wood_material, snd_click);

	NewtonMaterialSetFriction(			ivory_material, ground_material, 1.0, 0.8);
	NewtonMaterialSetElasticity(		ivory_material, ground_material, 0.5);
	NewtonMaterialSetDepthRecover(	ivory_material, ground_material, 0.2);
	NewtonMaterialSetSoundEffect(		ivory_material, ground_material, snd_poolball);	

	NewtonMaterialSetFriction(			ivory_material, ivory_material, 0.8, 0.4);
	NewtonMaterialSetElasticity(		ivory_material, ivory_material, 0.8);
	NewtonMaterialSetDepthRecover(	ivory_material, ivory_material, 0.2);
	NewtonMaterialSetSoundEffect(		ivory_material, ivory_material, snd_poolball);
	
	NewtonMaterialCollisionBegin(		water_material, wood_material, water_event);
	NewtonMaterialSetCollisionEnd(	water_material, wood_material, 0);
	NewtonMaterialCollisionContact(	water_material, wood_material, 0);
	NewtonMaterialCollisionBegin(		water_material, ivory_material, water_event);
	NewtonMaterialSetCollisionEnd(	water_material, ivory_material, 0);
	NewtonMaterialCollisionContact(	water_material, ivory_material, 0);
}

//-------------------------------------------------------------------------------------------------water
var fluidData[10];
function ApplyBuoyancy (body)
{
	// first make sure tha the body is in auto active mode
	NewtonSetBodyAutoActiveState (body, 1); 
	if (my._waterentity != 0) {
		//the body is in water, we want to be actine forever. this will hapen if the autoactive is setoff	
		NewtonSetBodyAutoActiveState (body, 0); 
		NewtonSetBodyActiveState (body, 1); 

		// get the water and reset the pointer
		p_tempent1 = my._waterentity;
		my._waterentity = 0;

		NewtonGetBuoyancyPlane (p_tempent1, fluidData);
		
		// fluid density
		fluidData[4] = p_tempent1.skill1; // skill1 water density
		fluidData[5] = p_tempent1.skill2; // skill2 water linear drag
		fluidData[6] = p_tempent1.skill3; // skill3 water angular density

		fluidData[7] = newtonGravity+(sin((total_ticks+my.x)*12)*40);
		//fluidData[7] = newtonGravity;


		fluidData[8] = my.skill6;  // skill7 body form factor

		NewtonBodyAddBuoyancy (body, fluidData);
		

	}
}

define _density, skill1;
define _linearviscosity, skill2;
define _angularviscosity, skill3;
//uses _density,_linearviscosity,_angularviscosity
action water_pool 
{
	var body;
	dll_handle = newtonHandle;
	
	if (my._density == 0.0) {
		my._density = 1.0;
	}

	my._waterentity = 0;	
	body = NewtonAddMapEntity (my, 0);
	NewtonSetBodyMass (body, 0);
	
	NewtonSetBodyMaterial (body, water_material);

}


//-------------------------------------------------------------------------------------------------enable_physics
function enable_physics()
{
	var body;
	dll_handle=newtonHandle;
	body=NewtonSpawnEntity(my,my._collisionshape);
	NewtonSetBodyMass(body,my._mass);
	NewtonSetBodyLinearDamp(body,my._lineardrag);
	NewtonSetBodyAngularDamp(body,my._angulardragx,my._angulardragy,my._angulardragz);
	NewtonSetBodyAutoActiveState(body,my._autorest);
	NewtonSetBodyActiveState(body,my._startactive);
	NewtonSetBodyMaterial(body,my._material);
	NewtonSetBodyForceAndTorque(body,p_phevent);
	return(body);
}


// Ball physics. - I don't think I need this: REMOVE

var torque[3];
var force[3];

function ball_event(body) 
{
	dll_handle=newtonHandle;
	var mass;
	mass=NewtonGetBodyMass(body);

	NewtonBodyAddForce(body,0,0,mass*(newtonGravity+force.z));
	NewtonBodyAddTorque(body,mass*torque.x,mass*torque.y,mass*torque.z);

	if(my._waterentity!=0) // in water
	{
		//NewtonBodyAddForce(body, thrust_force_x, thrust_force_y, 0));
		ApplyBuoyancy(body);
		NewtonSetBodyAutoActiveState(body,0);
	}
}


var temp1 [3];
var temp2 [3];




/*********************************************************************************
These functions to display a jet engine exhaust
*********************************************************************************/

bmap jet_tga = <jet.tga>;

// Helper function to fade out the jet exhaust
function jet_particle_fade()
{
	my.alpha -= 300 * time;
	my.size -= 5 * time;
	//	my.size /= 2;
	if (my.alpha <= 0) 
	{
		my.lifespan = 0;
	}
}

// Helper function to define the exhaust particles
function particle_jet()
{
	my.alpha = 10 + random(90);
	my.bmap = jet_tga;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.move = on;
	my.size = 1.5;
	my.function = jet_particle_fade; 
}

// NOT USED? REMOVE
function check_click()
{
	if (event_type == event_click) {
		display4=my.SHIP_NUM;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////
// This function is called by the action associated with each players spaceship. Since every
// entity runs on the server, one function for each players spaceship will be running on the server
// and is used to control the physics of each individual ship. It must run last (proc_late) so that
// we are guaranteed that the thruster will execute and 'show up' in the proper position. Otherwise
// we get 'thruster drift' where the thrusters show up at some previous location of the spaceship

// Unfortunately this has created a little problem. Since we are running on the server, the effects
// used to generate the thruster flames are running on the server as well. This creates a lot of 
// network traffic. The prefered method would be make 'show thruster' operate on the server and the
// the clients as local functions. In order to do this, each entity will need to start a function
// on every client, so that it can do the effect as well.
////////////////////////////////////////////////////////////////////////////////////////////////
// my = spaceship

sound jetEngineSound = <jetengine.wav>;

function control_spaceship()
{
	var temp_Keyflags;     
	var temp_aforce [3];   
	
	var prev_KeyFlags;     // previous loops Keyflag settings  (keyboard/joystick)
	var prev_aforce_pan;   // previous loops aforce settings (joystick)
	var prev_aforce_tilt;
	var prev_aforce_roll;
	
	var body;
	var jEShandle;
	var jESplaying;
	var hold_time;
	
	proc_late;

	while (!player) {wait(1);}  // wait for the player pointer to be defined before we  test it
	
	sleep (1);   // wait for my ship num to get here
	
	//	display1=my.SHIP_NUM;
	
	//	my.enable_click = on;   // allow the ship to be 'clicked';
	//	my.event=check_click;	
	while (1)
	{


		if (connection & 1) // we are running on the server
		{

			//			ship_keys[my.ship_num-1] = my.KeyFlags;  // DEBUG - show on server that we got the keys
			
			// first monitor the keyflags and if they changed since the last time, update all of the non-player clients
			// keyflags2 skill
			
			if (my.KeyFlags != prev_KeyFlags) 		 // only send the KeyFlags if they have changed.
			{
				my.KeyFlags2 = my.KeyFlags;
				send_skill(my.KeyFlags2,SEND_ALL); // send the key settings in reliable mode to all clients
			}

			
			// next monitor the aforce skills and if they changed, update the 'non-player' clients
			// aforce2 skills	
			
			if (my.aforce_pan != prev_aforce_pan) || (my.aforce_tilt != prev_aforce_tilt)|| (my.aforce_roll != prev_aforce_roll)
			{
				vec_set (my.aforce2, my.aforce);
				send_skill (my.aforce2,SEND_ALL+SEND_VEC);
			}

		}
		
		// Now decide if we are the 'players ship' or a 'Non Players' ship and use the appropriate controls

		if (my == player) // this is the players ship, so use the KeyFlags & aforce to control it
		{	
			temp_KeyFlags = my.KeyFlags;
			vec_set (temp_aforce, my.aforce);
		}
		else
		{ temp_Keyflags = my.KeyFlags2;
			vec_set (temp_aforce, my.aforce2);
		}
		

		// allow the ship to be controlled unless this ship is already a loser
		if (my.ENTITY_STATUS != LOSER) {

			
			// If the ship has not 'landed' then test the individual KeyFlags and aforce skills	
			
			if (temp_aforce.roll > 0) {roll_port(abs(temp_aforce.roll));}	
			if (temp_aforce.roll < 0) {roll_starboard(abs(temp_aforce.roll));}
			
			if (temp_aforce.tilt < 0) {tilt_up (abs(temp_aforce.tilt));}
			if (temp_aforce.tilt > 0) {tilt_down (abs(temp_aforce.tilt));}
			
			if (temp_aforce.pan > 0) {pan_port(abs(temp_aforce.pan));}	
			if (temp_aforce.pan < 0) {pan_starboard(abs(temp_aforce.pan));}	


			if (temp_KeyFlags & BIT0) {thruster_forward(7.5);}    
			if (temp_KeyFlags & BIT1) {thruster_aft(7.5);} 
			if (temp_KeyFlags & BIT2) {thruster_port(5);}
			if (temp_KeyFlags & BIT3) {thruster_starboard(5);} 
			if (temp_KeyFlags & BIT4) {pan_port(2.5);}            // was 2.5 but that seemed to slow 
			if (temp_KeyFlags & BIT5) {pan_starboard(2.5);}       // was 2.5
			if (temp_KeyFlags & BIT10) {thruster_decent(5);} 	

			
			if (temp_KeyFlags & BIT6) {tilt_up(5);} 
			if (temp_KeyFlags & BIT7) {tilt_down(5);} 
			if (temp_KeyFlags & BIT8) {roll_port(5);} 
			if (temp_KeyFlags & BIT9) {roll_starboard(5);} 	
			if (temp_KeyFlags & BIT11) {thruster_lift(5);}

		}

		if (temp_KeyFlags & BIT12) {fire_weapon();} 

		// save the various 'controls' for the next loop
		
		prev_KeyFlags = my.KeyFlags;
		
		prev_aforce_pan = my.aforce_pan;
		prev_aforce_tilt = my.aforce_tilt;
		prev_aforce_roll = my.aforce_roll;
	//}	
	wait(1);
}
}



// handle ship disconnects caused by players leaving the game


function disconnect_event ()
{
if (event_type == event_disconnect)
{
	ship_counter -=1;         // lower the number of active ships by one
	if (my.SHIP_NUM == 1) {yellow_ship = off;}
	if (my.SHIP_NUM == 2) {red_ship = off;}
	if (my.SHIP_NUM == 3) {green_ship = off;}
	if (my.SHIP_NUM == 4) {blue_ship = off;}
	
	wait(1);  // This wait is necessary to prevent the 'dangerous instruction' error msg when ent_remove during event.
	NewtonRemoveEntity(my);  // release this ship from the physics engine
	ent_remove (me);         // then remove the ship from the game
	mp_total_ships -= 1;
	mp_no_players -= 1;    // don't let them return on this round
	return;
}

}



// current skins: 1 = yellow
//                2 = red
//                3 = green
//                4 = blue

function determine_ship()
{
temp=color_used;
if (!yellow_ship){
	
	yellow_ship = on;	
	my.SHIP_NUM = 1;
	my.skin = my.SHIP_NUM;
	my.SHIP_COLOR = 1;
	return;
}

if (!red_ship){

	red_ship=on;
	my.SHIP_NUM = 2;
	my.skin = my.SHIP_NUM;
	my.SHIP_COLOR = 2;
	return;
}

if (!green_ship){
	green_ship = on;
	my.SHIP_NUM = 3;
	my.skin = my.SHIP_NUM;
	my.SHIP_COLOR = 3;
	return;
}

if (!blue_ship){

	blue_ship = on;
	my.SHIP_NUM = 4;
	my.skin = my.SHIP_NUM;
	my.SHIP_COLOR = 4;
	return;
}


}


// start the ships in the appropriate position based on the ship #
// save the ships ptr for game_control and for enemy_targeting
function place_ship() {

if (ship.SHIP_NUM == 4)  {
	vec_set (ship.x, vector(-200,6000,800));
	ship.pan = -90;
	ship.tilt = 0;
	ship.roll = 0;
	ship4_ptr = ship;
	ship4_handle = handle(ship4_ptr);
	send_var (ship4_handle);
}    	 // Start blue ship at   Pad 4
if (ship.SHIP_NUM == 3)  {
	vec_set (ship.x, vector(-100,6000,800));
	ship.pan = -90;
	ship.tilt = 0;
	ship.roll = 0;
	ship3_ptr=ship;
	ship3_handle = handle(ship3_ptr);
	send_var (ship3_handle);
} 	    // Start green ship at  Pad 3
if (ship.SHIP_NUM == 2)	{
	vec_set (ship.x, vector(100,6000,800));
	ship.pan = -90;
	ship.tilt = 0;
	ship.roll = 0;
	ship2_ptr=ship;
	ship2_handle = handle(ship2_ptr);
	send_var (ship2_handle);
} 	 // Start red ship at    Pad 2
if (ship.SHIP_NUM == 1)	{
	vec_set (ship.x, vector(200,6000,800));
	ship.pan = -90;
	ship.tilt = 0;
	ship.roll = 0;
	ship1_ptr=ship;
	ship1_handle = handle(ship1_ptr);
	send_var (ship1_handle);              // this send is not working. see cludge below
} 	    // Start yellow ship at Pad 1	
}

// this function was set up so that we can wait for the start of the game
// before enabling physics. That way the server's ship won't drift down while
// waiting for people to join

function setup_physics()
{
while (mp_no_physics) || (my.ENTITY_STATUS==WAITER){wait(1);}
enable_physics();
}

//////////////////////////////////////////////////////////////////////////////////////////
// desc: Main function for the spaceship entity
//       Runs only on the server, even for client spaceships
/////////////////////////////////////////////////////////////////////////////////////////



action spaceship
{
ship = my;
var body;
var jet_speed;
var particle_count;

// resize the ships!
my.scale_x = ship_scale;
my.scale_y = ship_scale;
my.scale_z = ship_scale;
c_setminmax(my);	

//	proc_late ();
dll_handle=newtonHandle;

my._collisionshape=0;  // box
my._mass=shipsmass;    // was 10
my._lineardrag=0.1;    //was 0.1
my._angulardragx=0.1;
my._angulardragy=0.1;
my._angulardragz=-10;   // was 0.1
my._autorest=0;
my._startactive=1;
my._material=ivory_material;
my._shapefactor=0.8; // density



p_phevent=ball_event;

// allow disconnects for client entity removal and ship_counter adjustments
my.ENABLE_disconnect=on;
my.event=disconnect_event;

ship_counter +=1;       // ship counter is only used for total # of players CHANGE TO total_players

my.ENTITY_STATUS = ACTIVE;

determine_ship();   // assign a ship number and color.

my.SPHERE_ENERGIZED=on;
my.HEALTH=100;
my.skin = my.SHIP_NUM;       // and set our skin to match our assigned ship
// current skins: 1 = yellow
//                2 = red
//                3 = green
//                4 = blue

my.ENTITY_TYPE = SHIP_TYPE;


my.min_z=-3.0;   // narrow my hull up a little so that the ship can 'touch' the hull of Lunar-4

//	IFNDEF NOBOUNDS;
//	my.NOFLY=on;
//	ENDIF;
//	

// IF MP then update everyone as to this entities position
ifdef server;
	ent_sendnow (me);
endif;


/**************************************************
***************************************************/



//	test_out_of_bounds();

control_spaceship();  // Start server side function to control the spaceship

sleep (1); // sleep here for proc_local ??

if (connection) {
	proc_local (my,control_spaceship); // and start the function on all the clients as well
}

if (my.ship_num == 1) {
	message_control();
	// display_time();
}
else {
	proc_client (my,message_control); // start up function to watch for and display messages
	// proc_client (my,display_time);    // start a function to display the time	
}
ship = me;
place_ship();   // set my shp_ptr and handl_ptr and place me where I should start
my.ENTITY_STATUS=WAITER;
setup_physics();

///***************************************************
//MULTIPLAYER
//The following code keeps track of the players and
//prevents someone from joining the middle of a game
//****************************************************/

mp_total_ships += 1;  // keep track of the number of players that have joined the game
// once total players = number we 'desire' we can start the countdown

// here we protect from getting more players than we wanted in the current round.
// if someone joins after we have started, they have to wait until the next game.

if (connection) {

	if (mp_total_ships > mp_no_players)  // and don't let to many join
	{
		mp_total_ships -= 1;
		while (!mp_restart_active)
		{ 
			wait (1);
		}
		
		mp_no_players += 1;  // let him join this round
		mp_total_ships += 1;
		txt_wait.visible = off;

		send_string_to (me,NOWAIT_STR);
	}
	
}
	my.ENTITY_STATUS = ACTIVE;	
}

//-------------------------------------------------------------------------------------------------actions for wed
//uses _mass,_lineardrag,_angulardragx,_angulardragy,_angulardragz,_shapefactor,_collisionshape,_autorest,_startactive



action oreHauler_entity 
{
my._material=wood_material;

my._collisionshape=0; // box
my._mass=500;
my._lineardrag=0.1;
my._angulardragx=0.1;
my._angulardragy=0.1;
my._angulardragz=0.1;
my._autorest=0;
my._startactive=0;
my._material=ivory_material;
my._shapefactor=0.8; // density

p_phevent=gravity_event;

sleep (1);

c_setminmax(my);                         // adjust the entity to it's size
enable_physics();

my.ENTITY_TYPE = ORE_HAULER;

while (1) {
	if (pad_no == 8) && (my.z < -100) { // should be -300
		ore_hauler_moved = 1;
		time_display_running = 0;       // turn off the timer			
	}
	wait(1);
}	
}

action captains_ship 
{
my._material=wood_material;

my._collisionshape=0; // box
my._mass=500;
my._lineardrag=0.1;
my._angulardragx=0.1;
my._angulardragy=0.1;
my._angulardragz=0.1;
my._autorest=0;
my._startactive=0;
my._material=ivory_material;
my._shapefactor=0.8; // density

p_phevent=gravity_event;

sleep (1);

c_setminmax(my);                         // adjust the entity to it's size
enable_physics();

my.ENTITY_TYPE = ORE_HAULER;
}

action dummy_ore_hauler 
{
my._material=wood_material;

my._collisionshape=0; // box
my._mass=500;
my._lineardrag=0.1;
my._angulardragx=0.1;
my._angulardragy=0.1;
my._angulardragz=0.1;
my._autorest=0;
my._startactive=0;
my._material=ivory_material;
my._shapefactor=0.8; // density

p_phevent=gravity_event;

sleep (1);

c_setminmax(my);                         // adjust the entity to it's size
enable_physics();

my.ENTITY_TYPE = ORE_HAULER;
}
