/*************************************************************************************
Lunar4Lander - 	A Multiplayer game based on controlling a spaceship via thrusters.
This game uses newton game physics to actually manipulate the spaceship (cause I don't have A6 Pro).

This is a 2010 version of Lunar lander. The basic idea here is that you must use a variety of thrusters 
to maintain control of your ship in a 3d space environment. 



Game Story:

You are a Tug recruit for the ore transport mothership - Lunar4. A Tug pilot's job is to move the larger ore carrying
ships about the mothership as needed. As a trainee, you will need to practice landing a Lunar4-Tug on the mothership 
without crashing into any of the ore ships. Once you've mastered your landing skills, you can progress to your first real 
job of moving ore-haulers down into the main bay of Lunar4. The most skilled tug pilots get the job of moving the 
ore-haulers into the ore processing center in the forward section of lunar4.  

For recreation on the long trips, tug-pilots like to play a game of 'Pad King', Challenge some other rookies 
in a game to see who can land on a pad first. 


PAD KING Rules:

Fly your ship using the keyboard or joystick to manuever with thrusters

Land at the designated landing pad before the other players. Bumping is permitted  Running into any of the docked ships 
will cost you the game (and probably get you an ass-chewing as well).



Futures:


1. Add ability to reassign controls on keyboard and joystick
2. Instructor Voice

3. Startup Menu
- Single / Multiplayer
- Keyboard Assignment
- Difficulty


4 change to use on_server to see when people join or leave 




Leasons Learned:

1. NewtonGravity needs to be a define. When I made it a var, I got this strange phenomenon where a sphere striking
a ship would occassionally cause what appeared to be positive gravity on all ships. Very Strange.

2. Multiple collision events occur when two entities under the physics engine strike each other. 
For example, when we 'touch' the pad, we might have two different events.
In one event the my = ship the you = pad. In the other, the my = pad and the you = ship. I'm
not sure if you get 'both events' at the same time, or if it is a random choice of one or the other. In any
case, you have to test for both conditions, or you will miss some important events.


Fixes attempts after this SAVE

1) Shields UP message - done
2. Better timing for mp. - done.  - Added 15 seconds to wait for startup. Also moved 
wait code for 'new players' to the end of spaceship code and added a WAITER
entity status.
3. Try Round shields instead of square in physics engine for dummy_ore_haulers - done
4. Practice Round
**************************************************************************************/


//var video_screen= 1;
//var video_mode = 4;
var video_mode = 5; // 512x384 pixels   to start with so I can get 4 windows on a screen (CHANGE to 7 Later)
//var video_mode = 7; //800x600 pixels
var video_mode = 8; //1024x768 pixels
var video_depth = 32; // 32 bit mode

/////////////////////////////////////////////////////////////////
// Filename of the starting level.
/////////////////////////////////////////////////////////////////
string level_str = <Lunar4Lander.WMB>; // give file names in angular brackets
string s_level=<Lunar4Lander.cls>;


/////////////////////////////////////////////////////////////////////////////////////////////////////
// skill definitions go here
/////////////////////////////////////////////////////////////////////////////////////////////////////

define CURRENT_OWNER, skill10;  // for launch pads. defines who owns them


//////////////////////////////////////////////////////////////////////////////////////////////////////
// The following definitions are used to keep track of the players control commands (ie keys). All keys
// are stored in a single word (skill1) for the player. This way we can send it over the internet
// with as little bandwidth as possible. Also since we only have a single word to worry about, it is
// easy to test and see if any key positions have changed. If no key changes are made, send nothing.
/////////////////////////////////////////////////////////////////////////////////////////////////////

define KeyFlags, skill51;  // Store the Keys being pressed by the player in skill 51

define BIT0 = 1;
define BIT1 = 2;
define BIT2 = 4;
define BIT3 = 8;
define BIT4 = 16;
define BIT5 = 32;
define BIT6 = 64;
define BIT7 = 128;
define BIT8 = 256;
define BIT9 = 512;
define BIT10 = 1024;
define BIT11 = 2048;
define BIT12 = 4096;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
// KeyFlags2 is a copy of KeyFlags that is echoed by the server to all the clients.
// That way 'Non Player' entities can see what keys were pressed by 'their players' and display the appropriate
// thuster flames
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
define KeyFlags2, skill52;  // used for the 'non-player' client entities to be able to display thruster flames


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// skills used to maintain Joystick information so that we can transmit it to the server
// These are handled in the same manner as the KeyFlags, but require 3 words to store. 
// All 3 words are transmitted in the same network packet, because we use a SEND_VECTOR option on aforce
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
define aforce,skill53;
define aforce_pan,skill53;
define aforce_tilt,skill54;
define aforce_roll,skill55;

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// aforce2 is similar in use to KeyFlags2, except it's for the joystick information. 
// It is a copy of aforce that is echoed by the server to all clients so that the 'non-player' client entities 
// to be able to display thruster flames.
///////////////////////////////////////////////////////////////////////////////////////////////////////////

define aforce2,skill56;
define aforce_pan2,skill56;
define aforce_tilt2,skill57;
define aforce_roll2,skill58;

var ship_scale = 1;  // set the size of the ships

var ship_keys[4];  //DEBUG - to prove that a ship is firing it's thrusters

define SHIP_COLOR,skill59;

define SHIP_NUM, skill60; // store my assigned ship number
define ENTITY_TYPE,skill61; // store what I am (a ship, a launch pad, an energy sphere);
define ENTITY_STATUS,skill62;
define SPHERE_ENERGIZED,skill63;

define OUT_OF_BOUNDS,skill64;  // Indicate ship is beyond edges of playing field
define NOFLY,skill65;
define WINNER,skill66;

define HEALTH,skill70;


// sub definitions of ENTITY_TYPE;
define SHIP_TYPE = 1;
define LANDING_PAD_TYPE = 2;
define ENERGY_SPHERE_TYPE = 3;
define ORE_HAULER = 4;

// sub definitions of ENTITY_STATUS;
define ACTIVE = 1;
define KILLED = 2;
define OUT_OF_BOUNDS = 3;
define WINNER = 4;
define LOSER = 5;
define PAD_OWNER = 6;
define PASS = 7;
define FAIL = 8;
define PAD_OWNER_MP = 9;
define WAITER = 10;


var yellow_ship = off;
var red_ship = off;
var green_ship = off;
var blue_ship = off;


var color_used=0;   // all colors initially available
var ship_righted;

/////////////////////////////////////////////////////////////////
// Variables used to manage the overall game 
////////////////////////////////////////////////////////////////

var fps_max = 35; // no need to go any faster that 35 fps

view aum_camera{};

var camera_number = 4;   // default camera is 4

var save_cam_number;
var oldpan [3];
var cam_temp [3];	
var cam_old_dist;
var cam_sav_pos [3];
var cam_vec_diff [3];
var cam_sav_pantiltroll [3];
var cam4_old_pos [3];
var cam7_old_pos [3];

var ship_counter; // save the number of ships that are active in the game
var ships_out_of_bounds;

var ship_scores [4];

var landing_location = 3;
entity* landing_indicator;
entity* cross_hair;
// TEMPORARY so I can display various ship skills as needed
entity* ship; 
entity* ship1_ptr;
entity* ship2_ptr;
entity* ship3_ptr;
entity* ship4_ptr;
entity* mp_ship_ptr;

var ship1_handle;
var ship2_handle;
var ship3_handle;
var ship4_handle;

// temporary variables for displaying stuff
var special_temp1;  
var display1;
var display2;
var display3;
var display4;
var display5;
var display6;
var display7;

var c_result;  // used for the aum_camera to keep it out of walls

var elapsed_time = 60;
var adjusted_elapsed_time;
var time_display_running = 0;        // control the landing timer for single player game
var ship_landed = 0;                 // indicate that the ship has touched down on the desired pad

var pad_location [3];
var pad_boundaries_upper [3];
var pad_boundaries_lower [3];
var pad_distance;                    // distance ship touched down from pad
var Camera_Active;
var pad_no;                          // which landing pad to use
var mp_pad_owner;                    // indicate who touched the pad 
var mp_prev_pad_owner;               // indicate who previously had it (zero if no owner)
var mp_pad_owner_handle;             // store the handle of the pad owner;
var mp_pad_owner_ptr;                // A pointer to the owner of the pad
var mp_no_players;                   // The number of players that will be participating in MP game
var mp_no_physics;                    // indicates not to apply any physics (due to crashes when removing entities from newton)
var mp_total_ships;                  // keep track of the number of ships in the game
var mp_loser_ships;                 // Keep track of the number of ships that have lost

var mp_starting_countdown;
var mp_restart_active;

var ore_hauler_moved = 0;           // used to indicate the ore_hauler has been successfully moved to lower deck
var move_hauler_failed = 0;         // used to count the number of failed attempts to move the hauler below deck

var no_timer = 0;                 // shut off timer with this flag (for practice)
var debug1;
var debug2;
var debug3;
var debug4;
var debug5;
var debug6;
var debug7;

// multiplayer control strings 

string start_countdown = "SCD";
string no_physics = "NOP";
string ok_physics = "OKP";
string WAIT_STR = "WTS";
string NOWAIT_STR = "NWS";
string PREPARE_STR = "PRP";
string NOPREPARE_STR = "NRP";
string CHG_PAD_STR = "CPD";



//--------------------------------------------------------------------
// Fonts
//--------------------------------------------------------------------
font fnt_century12	= <Centur12.pcx>,16,20; // Century12 font

font sm_font = "Arial",1,15;  // truetype font 
font med_font = "Arial",1,50; // truetype font
font lg_font = "Arial",1,125; // truetype font
FONT digi_font,<msgfont.pcx>,12,16;

//////////////////////////////////////////////////////////////////////
// Screem messages
/////////////////////////////////////////////////////////////////////

text txt_out
{
	layer = 300; pos_x = 250;pos_y = 150; font = med_font; string = "OUT"; alpha = 40;
	flags = center_x, narrow, transparent;
}

text txt_win
{
	layer = 300; pos_x = 250;pos_y = 150; font = lg_font; string = "Winner"; alpha = 75;
	flags = center_x, narrow, transparent;
}

text txt_lock
{
	layer = 300; pos_x = 275;pos_y = 150; font = lg_font; string = "Locked"; alpha = 75;
	flags = center_x, narrow, transparent;
}

text txt_hold
{
	layer = 300; pos_x = 275;pos_y = 150; font = lg_font; string = "Hold"; alpha = 75;
	flags = center_x, narrow, transparent;
}
text txt_lose
{
	layer = 300; pos_x = 250;pos_y = 150; font = lg_font; string = "Loser"; alpha = 75;
	flags = center_x, narrow, transparent;
}

text txt_pass
{
	layer = 300; pos_x = 250;pos_y = 150; font = lg_font; string = "Passed"; alpha = 75;
	flags = center_x, narrow, transparent;
}

text txt_fail
{
	layer = 300; pos_x = 250;pos_y = 150; font = lg_font; string = "Failed"; alpha = 75;
	flags = center_x, narrow, transparent;
}

text txt_wait
{
	layer = 300; pos_x = 500;pos_y = 150; font = med_font; string = "Waiting to Join"; 
	alpha = 75; flags = center_x, narrow, transparent;
}

text txt_mp_setup {
	layer = 300; pos_x = 150;pos_y = 100; font = med_font; 
	string = "Preparing for Pad King tournament"; 
	//alpha = 75;flags = center_x, narrow;	
	alpha = 75;flags =  narrow, transparent;
}
text txt_all_present {
	layer = 300; pos_x = 150;pos_y = 200; font = med_font; 
	string = "All Present - Preparing to start"; 
	//alpha = 75;flags = center_x, narrow;	
	alpha = 75;flags =  narrow, transparent;
}
text txt_pad1Lower
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Lower Deck Pad 1 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad2Lower
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Lower Deck Pad 2 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad3Lower
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Lower Deck Pad 3 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad1Upper
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Upper Deck Pad 1 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad2Upper
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Upper Deck Pad 2 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad3Upper
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Upper Deck Pad 3 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad1Interior
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Interior Hold Pad 1 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
text txt_pad2Interior
{
	layer = 300; pos_x = 800;pos_y = 50; font = sm_font; string = "Interior Hold Pad 2 Active"
	; alpha = 75;flags = center_x, narrow, transparent;  
}
////////////////////////////////////////////////////////////////////////////////////////////////////
// Function Predefines go here
////////////////////////////////////////////////////////////////////////////////////////////////////

function thruster (&loc,&src,power);

include <newton.wdl>; // newton interface
include <camera.wdl>;
include <L4LPhysics.wdl>;
include <L4Lmisc.wdl>;


ifdef USE_NEWTON_GAME_DYNAMICS;
	string newtonLevel_cls=s_level;
endif;


var Distance_traced = 0;



/***********************************************************************
The following panel is to display the starting countdown
************************************************************************/
panel start_timer_panel 
{
	pos_x =170;
	pos_y =300;
	flags =refresh;
	digits 190,00,5.0,lg_font,1,mp_starting_countdown;


}

/************************************************************************
This panel is used to show that we are waiting on players to join
*************************************************************************/

panel mp_wait_panel 
{
	pos_x =200;
	pos_y =120;
	flags =refresh;
	
	digits (0,30,"Players",med_font,0,0);
	digits 200,30,1.0,med_font,1, mp_total_ships;
	digits (400,30,"Needed",med_font,0,0);
	digits 600,30,1.0,med_font,1,mp_no_players;
	
}


//
//panel debug_panel 
//{
	//	pos_x =0;
	//	pos_y =0;
	//	flags =refresh,visible;
	//	
	//	
	//	digits 200,600,5.5,fnt_century12,1,debug1;
	//	digits 200,620,5.5,fnt_century12,1,debug2;
	//	digits 200,640,5.5,fnt_century12,1,debug3;
	//	digits 400,600,5.5,fnt_century12,1,debug4;
	//	digits 400,620,5.5,fnt_century12,1,debug5;
	//	digits 400,640,5.5,fnt_century12,1,debug6;
	//	digits 400,660,5.5,fnt_century12,1,debug7;
	//	
//}
//


// mp start countdown screen runs on client and server

function mp_start_countdown_screen () {
	mp_starting_countdown = 10;
	start_timer_panel.visible = on;  
	while (mp_starting_countdown > 0)
	{ 	
		sleep(1);
		mp_starting_countdown -= 1;
	}
	
	start_timer_panel.visible = off;
	
	
	// the following is in this code because we have a sleep happening in this function
	// this causes the function to return to the caller, and this thread to run independently
	// Therefore mp_no_physics must be in this routine, not the callers routine
	
	
	mp_no_physics = 0;   // allow physics to happen again
	send_var (mp_no_physics);
	mp_restart_active = 0; // let every know we have restarted
	send_var (mp_restart_active);
	
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
// The following code handles the camera's for the player. Therefore player references are valid in
// this code. It is 'client code' and will run on both the client and the server. 
//
// Called from main();
//
/////////////////////////////////////////////////////////////////////////////////////////////////////






function landing_indicator_control()
{
	var body;
	my.passable=off;
	my.ENTITY_TYPE = LANDING_PAD_TYPE;
	
	dll_handle=newtonHandle;

	my._collisionshape=0;  // box
	my._lineardrag=0.1;    //was 0.1
	my._angulardragx=0.1;
	my._angulardragy=0.1;
	my._angulardragz=-10;   // was 0.1
	my._autorest=0;
	my._startactive=1;
	my._material=ivory_material;
	my._shapefactor=0.8; // density
	p_phevent=ball_event;
	
	body=enable_physics();
	while (1) {
		if(!connection) {
			if (!ship_landed){
				pad_distance = vec_dist(my.x,player.x); // calculate distance from landing pad to player
			}
		}
		wait (1);
	}
	
}

function cross_hair_control()
{
	var body;
	my.scale_x = 20;
	my.scale_y = 20;
	//	my.scale_z = 5;
	my.passable=on;
	my.overlay=on;
	my.tilt=90;
	//
	//	while (1) {
		//		// any code we might need for the cross hair should go here. 
		//		// I can probably eliminate this loop completely, as the cross hair serves no function
		//		wait (1);
	//	}
	//	
}


function pad_indicator_message() {

	wait(1); // so that we immediately return to the event_client function if on client
	
	// first shut off all previous messages
	txt_pad1Lower.visible=off;
	txt_pad2Lower.visible=off;
	txt_pad3Lower.visible=off;
	txt_pad1Upper.visible=off;
	txt_pad2Upper.visible=off;
	txt_pad3Upper.visible=off;
	txt_pad1Interior.visible=off;
	txt_pad2Interior.visible=off;
	
	// now indicate the correct pad to land on
	
	if (pad_no == 1){
		txt_pad1Lower.visible=on;	
	}	
	if (pad_no == 2){
		txt_pad1Upper.visible=on;	
	}
	if (pad_no == 3){
		txt_pad2Upper.visible=on;	
	}
	if (pad_no == 4){
		txt_pad2Lower.visible=on;	
	}
	if (pad_no == 5){
		txt_pad3Lower.visible=on;
	}
	if (pad_no == 6){
		txt_pad1Interior.visible=on;	
	}
	if (pad_no == 7){
		txt_pad2Interior.visible=on;
	}
}

function create_landing_indicator()
{
	// turn on the appropriate pad indicator message
	pad_indicator_message();


	if (pad_no == 1) {
		vec_set (pad_location,vector(480,4500,130));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // lower  Pad 1		
	}	
	if (pad_no == 2){

		vec_set (pad_location,vector(500,4200,470));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // Upper Deck Pad 1
	}
	if (pad_no == 3){
		
		vec_set (pad_location,vector(650,3800,470));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // Upper Deck  Pad 2
	}
	if (pad_no == 4){
		
		vec_set (pad_location,vector(480,4150,130));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // lower  Pad 2		
	}
	if (pad_no == 5) {

		vec_set (pad_location,vector(760,3800,130));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // lower	pad 3	
	}

	if (pad_no == 6) {

		vec_set (pad_location,vector(500,2760,-382));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // Interior Pad 1	
	}
	if (pad_no == 7) {

		vec_set (pad_location,vector(480,4400,-455));
		landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // Interior Pad 2	
	}	

	//	 level2 - all landing pads passed... rookie to start job and move designated ships to lower level

	if (pad_no == 8) {
		distance_panel.visible=off;
		vec_set (pad_location,vector(600,4150,-465));
		//landing_indicator =ent_create("landing_marker2.mdl",pad_location,landing_indicator_control); // Interior Pad 2
		cross_hair = ent_create("cross.pcx",vector(775,3620,130),cross_hair_control);
		
	}
}





BMAP arrow = <arrow.pcx>; 


function mouse_hunt() {

	MOUSE_MAP = arrow; // Arrow as Mouspointer!
	MOUSE_MODE=0;

	while (1) // move it over the screen
	{ 
		if (!free_look) {
			mouse_mode = 1; 
			MOUSE_POS.X = POINTER.X;
			MOUSE_POS.Y = POINTER.Y;
			if (mouse_ent) {
				display5=mouse_ent.SHIP_NUM;
				if (mouse_left) && (mouse_ent != player) {
					target_enemy=mouse_ent;
				display7=target_enemy.SHIP_NUM;}
				} else {
			display5=0;}
			} else {
		mouse_mode = 0;}
		wait(1);
	}
}

/***********************************************************************
* Game restart code for Multiplayer
************************************************************************/
function mp_game_restart () {
	var i;
	mp_no_physics=1;   // shut down physics since we are removing NewtonEntities
	mp_restart_active = 1;   // signal we have a game restart condition
	send_var (mp_no_physics);	
	send_var (mp_restart_active);
	
	// remove the pad and set up for the next one.
	NewtonRemoveEntity(landing_indicator);  // release this ship from the physics engine	
	ent_remove(landing_indicator);
	pad_no = int(random (7))+1;  // on the server calculate the pad
	if (pad_no == 8) {           // but don't let it be pad 8 (i don't think we need this but just in case)
		pad_no = 7;
	}
	send_var (pad_no);           // and let the clients know which pad
	send_string(CHG_PAD_STR);     // and tell them to switch messages
	create_landing_indicator();
	
	// now put the ships back where they belong
	
	i=1;  // reset our counter	
	while (i < mp_no_players+1) {
		
		
		if (i == 4)  {
			ship=ship4_ptr;
			NewtonRemoveEntity(ship);  // release this ship from the physics engine
			place_ship();              // move this ship back to the starting line 
		}           
		if (i == 3)  {
			ship=ship3_ptr;
			NewtonRemoveEntity(ship);  // release this ship from the physics engine
			place_ship();             // move this ship back to the starting line
		}
		
		if (i == 2)  {
			ship=ship2_ptr;
			NewtonRemoveEntity(ship);  // release this ship from the physics engine
			place_ship();             // move this ship back to the starting line
		}
		if (i == 1)  {
			ship=ship1_ptr;
			NewtonRemoveEntity(ship);  // release this ship from the physics engine
			place_ship();              // move this ship back to the starting line
		}					
		

		ship.ENTITY_STATUS=ACTIVE;             // reactivate this ship
		send_skill(ship.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
		
		my=ship;                             // set my so enable_physics will work
		enable_physics();                    // restore physics to this ship (ok here cause mp_no_physics prevents use for now)
		i+=1; // next ship
		
	}
	
	// reset some stuff
	mp_pad_owner = 0;
	mp_loser_ships = 0;
}

/************************************************************************
this code will monitor the overall game and declare winners and losers

Multiplayer rules
1) you must 'touch the pad' and maintain control of it for 10 seconds.
2) You must maintain a distance that is very close to the pad at the end of 10 seconds
3) No one else can 'touch the pad' during the 5 seconds

**************************************************************************************/ 

function multiplayer_monitor () {
	var lock_time;
	var pad_distance;
	var i;

	// code to keep players from moving their ships until all players are present

	mp_no_physics = 1;
	send_var (mp_no_physics);
	
	mp_wait_panel.visible=on;                     // only the server sees this panel
	while (mp_no_players > mp_total_ships) {
		wait (1);
	} 

	// all desired players present wait a bit and then start up
	
	mp_wait_panel.visible=off;
	txt_all_present.visible=on;
	sleep (15); // wait awhile for all the players to get fully initialized
	txt_mp_setup.visible=off;
	txt_all_present.visible=off;
	send_string(NOPREPARE_STR);
	
	send_string(NOWAIT_STR);
	
	send_var (pad_no);           // and let the clients know which pad
	send_string(CHG_PAD_STR);        // and tell them to switch messages	
	
	send_string(start_countdown); // let the client know it's time to start countdown
	
	mp_start_countdown_screen();


	// ok, the game has started, so keep an eye on everything in this big loop	

	while (1)	
	{

		// Code to handle all of the ships being losers
		
		if (mp_loser_ships >= mp_no_players) {
			mp_game_restart ();
			send_var (pad_no);           // and let the clients know which pad
			send_string(CHG_PAD_STR);        // and tell them to switch messages	
			mp_start_countdown_screen ();
		} // END if (mp_loser_ships >= mp_no_players)
		
		// code to handle the fact that we have a winner

		if (mp_pad_owner) {    // someone touched down, start the clock
			lock_time += time_frame / 16;
			if (mp_prev_pad_owner != mp_pad_owner) {  // someone else has the pad start over
				lock_time = 0;
				mp_prev_pad_owner = mp_pad_owner; 
			} // END if (mp_pad_owner)
			
			
			if (lock_time > 10.0) {
				mp_ship_ptr = ptr_for_handle (mp_pad_owner_handle); // get a pointer to the owner of the pad
				pad_distance = vec_dist(landing_indicator.x,mp_ship_ptr.x); // calculate FINAL distance from landing pad to player
				display4 = pad_distance;
				if (pad_distance < 50) {  // we have a winner
					mp_ship_ptr.ENTITY_STATUS = WINNER;	
					send_skill(mp_ship_ptr.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
					
					
					
					// Now we update the loosers and take everyone out of the physics engine
					// so that we can move them to the restart position
					
					i=1;
					while (i < mp_no_players+1)
					{
						if (i==1)   {
							my=ship1_ptr;
							if (i != mp_pad_owner) {         
								my.ENTITY_STATUS = LOSER; // ;let'em know they lost
								send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
							}	
						}							
						if (i==2)  {
							my=ship2_ptr;
							if (i != mp_pad_owner) {
								my.ENTITY_STATUS = LOSER;	
								send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
							}
						}
						if (i==3) {
							my=ship3_ptr;
							if (i != mp_pad_owner) {
								my.ENTITY_STATUS = LOSER;
								send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients	
							}
						}
						if (i==4)  {
							my=ship4_ptr;
							if (i != mp_pad_owner) {
								my.ENTITY_STATUS = LOSER;
								send_skill(my.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
							}
						}
						i+=1;
						
					}  // END 	while (i < mp_no_players+1)
					
					// we had a winner, so let's restart the whole dang thing (this is in the wrong place)
					
					mp_no_physics = 1;              // stop physics controls
					send_var (mp_no_physics);

					sleep (5);                      // let the winner bask in the glory of the win
					
					mp_game_restart();              // now restart the game
					
					// ok, we should be able to start a countdown here and display the countdown panel
					
					send_string(start_countdown); // let the clients know it's time to start countdown
					send_string(NOWAIT_STR);
					send_string(NOPREPARE_STR);					

					send_var (pad_no);           // and let the clients know which pad
					send_string(CHG_PAD_STR);        // and tell them to switch messages	
					
					mp_start_countdown_screen();
					

				} // END if (pad_distance < 50)
				else { 
					// he must have drifted to far, restart activity
					mp_pad_owner = 0;  
					lock_time = 0;
					mp_prev_pad_owner = 0;
					mp_ship_ptr.ENTITY_STATUS=ACTIVE;
					send_skill(mp_ship_ptr.ENTITY_STATUS,SEND_VEC + SEND_ALL); // send to the clients
				}  // END else
			} // END if (lock_time > 10.0)
		} // END if (mp_pad_owner) 
		else  	
		{   
			lock_time = 0;
		} // END else
		wait(1);		
	} // END while (1)
} // END multiplayer_monitor






// This code will attempt to restart the game after a succesful landing. 
// Scoring will determine if we should advance to the next pad.




function restart_monitor() {
	var lock_time;
	while (1)	{
		if (ore_hauler_moved) || ( move_hauler_failed > 1) {
			exit_game();
		}
		if (ship_landed) {
			pad_distance = vec_dist(landing_indicator.x,player.x); // calculate FINAL distance from landing pad to player
			//pad_distance = display4 - 12;  // Display Score - we can only get to within 12 of the center
			// debug
			display1 = player.pan;
			display2 = player.tilt;
			display3 = player.roll;
			display4 = pad_distance;
			
			if (!ship_righted) {right_ship(player);}  // level up the ship and place on the pad
			lock_time += time_frame /16;
			if (lock_time > 5) {
				
				// pad's 1-6 require a score of less than 121 to pass on to the next pad
				// pad's 1-6 require that elapsed time is > 0 and distance_to_pad < 40.
				if(pad_no < 8) {				
					if (pad_distance < 31) && (elapsed_time > 0) && (player.ENTITY_STATUS != LOSER){
						player.ENTITY_STATUS = PASS;
						} else {
						player.ENTITY_STATUS = FAIL;
					}	
				}				
				NewtonRemoveEntity(landing_indicator);  // release this ship from the physics engine	
				ent_remove(landing_indicator);
				sleep (1);  // This wait is necessary to prevent the 'dangerous instruction' error msg when ent_remove during event.
				NewtonRemoveEntity(player);  // release this ship from the physics engine
				//				ent_remove(player);          // Then get rid of the ship           
				yellow_ship = off;
				

				// go to the next pad if we passed
				// NOTE: in practice mode, we only allow the first pad to practice on.
				if (player.ENTITY_STATUS == PASS) && (!no_timer) {
					pad_no += 1;   // advance to next pad
				}
				create_landing_indicator();
				ship_landed =0;
				lock_time = 0;
				if (pad_no < 6)	{
					elapsed_time = 60;
					} else {	
					if (pad_no < 8) { 
						elapsed_time = 120;
					} else
					{
						elapsed_time = 300;
					}
				}
				
				player.ENTITY_STATUS=ACTIVE;
				if (pad_no == 8) {
					help_panel.visible=off;
					message_end_landing_test ();
					while (message_running) {wait (1);}  // spin till message compete
					distance_panel.visible=off;
				}
				
				ship=player;
				place_ship();
				my=player;              // reset my to player
				enable_physics();       // restore physics
				mp_no_physics = 0;   // allow physics for this ship
				ship_righted = 0;    // reset this flag to indicate the ship may not be righted any more
				
			}
		}
		if (elapsed_time == 0) {
			mp_no_physics = 1;   // lock out thrusters
			player.entity_status = fail;
			//		NewtonRemoveEntity(landing_indicator);  // release this pad from the physics engine	
			//		ent_remove(landing_indicator);
			sleep (7);  // wait a little bit to let them 'see' that they failed
			NewtonRemoveEntity(player);  // release this ship from the physics engine          
			yellow_ship = off;                       // hide the ship for a second
			ship_landed =0;
			lock_time = 0;
			if (pad_no < 6)	{
				elapsed_time = 60;
				}else{ 
				if (pad_no < 8) { 
					elapsed_time = 120;
				} else
				{
					elapsed_time = 300;
					move_hauler_failed += 1;   // keep track of failed attempts to move the ore hauler below deck				
				}
				
			}		player.ENTITY_STATUS=ACTIVE;
			ship=player;
			place_ship();
			my=player;              // reset my to player
			enable_physics();       // restore physics
			mp_no_physics = 0;   // allow physics for this ship	
			
			
		}
		wait(1);
	}
	
}

/////////////////////////////////////////////////////////////////
// Desc: The main() function is started at game start
/////////////////////////////////////////////////////////////////

function main()
{
	// set some common flags and variables
	// freeze all entity functions
	freeze_mode = 1;


	// entry: Warning Level (0,1, or 2)
	// entry_help: Sets sensitivity to warnings (0 = none, 1 = some, 2 = all).
	warn_level = 2;	// announce bad texture sizes and bad wdl code


	// entry: Starting Mouse Mode (0, 1, or 2)
	mouse_mode = 1;

	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// now load the level
	level_load(level_str);

	wait(2);	// let level load
	// level should be loaded at this point...

	ifdef client;
		// make sure we have a networking connection before proceeding
		while (connection == 0) { wait(1); }
	endif;

	if (connection == 3) {

		mp_no_players = 2;  // default is to wait for 2 players in mp
		
		IFDEF WAIT1;
		mp_no_players=1;
		ENDIF;

		IFDEF WAIT2;
		mp_no_players=2;
		ENDIF;

		IFDEF WAIT3;
		mp_no_players=3;
		ENDIF;

		IFDEF WAIT4;
		mp_no_players=4;
		ENDIF;

	}




	ifdef USE_NEWTON_GAME_DYNAMICS;
		dll_handle=newtonHandle;
		NewtonAddMap(s_level,0);
	endif;


	player=ent_create("dbm.mdl",vector(4021,1936,-118),spaceship); 

	sleep (1);
	player.pan = -90;   // face Lunar 4
	
	start_timer_panel.visible=off;
	txt_out.visible=off;

	// un-freeze the game
	freeze_mode = 0;

	gather_inputs();



	// elapsed_time = 300; // REMOVE THIS - here to test pad 7 and 8 changeover
	if (connection == 0) {
	pad_no = 1;} else
	{  // must be multiplayer
		
		txt_mp_setup.visible=on;    // put up Pad King tourney message
		if (connection != 2)	  // turn the setup message on the server
		{
			randomize();
			pad_no = int(random (7))+1;  // on the server calculate the pad
			if (pad_no == 8) {           // but don't let it be pad 8 (i don't think we need this but just in case)
				pad_no = 7;
			}
			send_var (pad_no);           // and let the clients know which pad
			send_string(CHG_PAD_STR);     // and tell them to switch messages	
			} else {
			txt_wait.visible=on;
		} 	
	}   

	if (connection == 0) || (connection == 3)  {
		create_landing_indicator ();
	}
	if (connection == 0) {          // only display the time & distance in single player mode
		display_time();
		restart_monitor();
		message_gamestart();
	}

	mp_no_physics=1;
	sleep (15); 
	handle_camera();               // new camera code
	mp_no_physics=0;
	
	if (connection) {	
		mp_no_physics = 1;    // always start client and server processes with physics disabled
	}

	ifdef server;   		
		multiplayer_monitor ();    // only run the monitor on the server (or server/client)
	endif;


}


sky sky_cube {
	type = <skycube3+6.tga>;
	flags = cube,visible;
	layer = 10;
}


function target_ship1 ()
{
	if (ship1_handle != null) {
		ship1_ptr = ptr_for_handle(ship1_handle);
		target_enemy=ship1_ptr;
	}
}
function target_ship2 ()
{
	if (ship2_handle != null) {
		ship2_ptr = ptr_for_handle(ship2_handle);
		target_enemy=ship2_ptr;
	}
}
function target_ship3 ()
{
	if (ship3_handle != null) {
		ship3_ptr = ptr_for_handle(ship3_handle);
		target_enemy=ship3_ptr;
	}
}
function target_ship4 ()
{
	if (ship4_handle != null) {
		ship4_ptr = ptr_for_handle(ship4_handle);
		target_enemy=ship4_ptr;
	}
}

function client_event (str) {
	if ((event_type == event_string) && (str == start_countdown)) {
		mp_start_countdown_screen();
	}
	if ((event_type == event_string) && (str == WAIT_STR)) {
		txt_wait.visible = on;
	}
	if ((event_type == event_string) && (str == NOWAIT_STR)) {
		txt_wait.visible = off;
	}	
	if ((event_type == event_string) && (str == PREPARE_STR)) {
		txt_mp_setup.visible = on;
	}
	if ((event_type == event_string) && (str == NOPREPARE_STR)) {
		txt_mp_setup.visible = off;
	}
	if ((event_type == event_string) && (str == CHG_PAD_STR)) {
		pad_indicator_message();
	}
}


function no_target ()
{
	target_enemy = null;
	display6=0;
}


on_client = client_event;

on_1 = target_ship1;
on_2 = target_ship2;
on_3 = target_ship3;
on_4 = target_ship4;
on_0 = no_target;
