var camera_adjust_x;
var camera_adjust_y;
var camera_adjust_z;
var result2;
var result3;
var temp2;
var free_look;

/********************************************************************************************
This code is taken from a user contribution called zelda.lockon. 

Here is some info from user contribution forums thread:

Ultimate Zelda lock on camera! 
POST #707960 - Fri Nov 24 2006 02:43 PM 

Got this nice lock on camera working with the Kingdom Hearts code and wanted to share.
As far as I can tell it's the same camera as in Zelda: Ocarina of Time. The goal was to keep 
the lock on target and the player in view at all times but also have the camera avoid clipping 
walls and have a nice angle on the scene. Lock onto a target high up in the air or below you 
and the camera will move accordingly Here is the download:

http://www.churness.com/axys/ZeldaLockOn.zip (link should work, 
if it doesn't read posts below incase url has changed)

All resources in this project are free for you to use in any commercial project. Things are u
npolished and the code, even though built upon the Kingdom Hearts code, will have some 
additions that may be difficult to understand, so use and attempt to understand at your own risk 
There are plenty of things that could be added to this, I just wanted to show you the lock
on code :) 
*****************************************************************************************/

/******************************************************************************************


Here is the user info:

Profile for DavidLancaster  

Email       
Member #  14314    
Name     
Title  Developer    
Total Posts  520    
Rating **** Birthday  10/28/1984   
Homepage  http://www.rebelplanetcreations.com    
Occupation  Game Developer    
Hobbies     
Location  Adelaide, Australia    
Bio     
ICQ Number     
Gamestudio Version  A6 Commercial 6.40.5   
Registered on  Tue Nov 23 2004 08:42 AM   

*******************************************************************************************/
/******************************************************************************************** 


Basically it is camera code that does a couple of interesting things.

1. The camera has a free look mode that always keeps your player entity in sight. I like this
alot and plan on incorporating this into RigForImpact

2. The 3rd person camera has some interesting aspects. 
a) It follows the player when the player is moving forward, but stays in a stationary position 
when the player is turning. This seems interesting to me. I'm not sure if it would work in 
RigForImpact, but I would like to try it out.
b) It seems to have pretty good 'no clipping' code.
c) The camera position 'interpolates' between the desired location and current location

3. The lockon camera basically let's you click on an enemy. When you do a ring of circles indicates
which enemy you have choosen. Your player entity then ALWAYS faces this enemy. The camera
stays locked on as well, so you always are viewing your entity and the enemy. I'm not sure
that this fits RigforImpact, but might be very useful in a full 3d space game or in the
dogfight game. basically always seeing and following your enemy might be pretty cool option.
Maybe a seperate targeting function to 'aim' the guns, rather than 'auto kill' type of thing.

NOTE: I have made extensive changes to this camera code.
**********************************************************************************************/

//////////////////////////////
// camera variables
//////////////////////////////

var camera_move_to[3];
var camera_pan_to[3];
var camera_pan_force[3];
var camera_pan_velocity[3];
var camera_interpolate_state;
var camera_view_position[3];
var camera_view_to[3];
var camera_spin_speed = 1;
var camera_distance = 215;
var camera_pan;
var camera_tilt;

entity* target_enemy;

// Handle gradual change of vectors

FUNCTION move_variable(variable_to_move,move_to_pos,move_speed) {
	IF (variable_to_move == move_to_pos) { return(variable_to_move); }
	var a;
	a = variable_to_move - move_to_pos;
	IF (a > 0) {
		variable_to_move -=  move_speed * time_step;
		IF (variable_to_move - move_to_pos < 0) { variable_to_move = move_to_pos; return(variable_to_move); }
		} ELSE {
		IF (a < 0) {
			variable_to_move +=  move_speed *time_step;
			IF (variable_to_move - move_to_pos > 0) { variable_to_move = move_to_pos; return(variable_to_move); }
		}
	}
	return(variable_to_move);
}


// Probably the main call that decides which type of camera to use.
// subroutine to rotate the camera to the desired view
// Called by handle_3rd_camera


FUNCTION handle_camera_rotation {
	camera_view_position.x = move_variable(camera_view_position.x,camera_view_to.x,abs(camera_view_position.x - camera_view_to.x));
	camera_view_position.y = move_variable(camera_view_position.y,camera_view_to.y,abs(camera_view_position.y - camera_view_to.y));
	camera_view_position.z = move_variable(camera_view_position.z,camera_view_to.z,abs(camera_view_position.z - camera_view_to.z));
	vec_diff(temp.x,camera_view_position.x,camera.x);
	vec_to_angle(temp.pan,temp.x);
	camera.pan = temp.pan;
	camera.tilt = temp.tilt + 6;
	IF (camera_interpolate_state == on) {

		camera_interpolate_state = off;
		IF (abs(camera_pan_to.pan - camera.pan) == 0) && (abs(camera_pan_to.tilt - camera.tilt) == 0) {
			IF (target_enemy == null) {
				camera_interpolate_state = off;
				} ELSE {
				camera_interpolate_state = on + 1;
			}
		}
	}
}



// probably the 3rd person camera function. This is most likely what I want to use

FUNCTION handle_3rd_camera() {
	//	var save_cam_pan;

	// if player toggled free_look (via left mouse button) then move camera based on mouse movement
	IF (free_look) { 	
		camera_pan -= mouse_force.x * 12 * time; 
		camera_tilt += mouse_force.y * 8 * time;
		camera_tilt = clamp(camera_tilt,-60,60);    // was -30,10
		
		
	}


	camera.pan = camera_pan;      // change camera base on mouse adjustments.



	// if we are not in free look, then adjust the camera to be located directly behind the ship

	if (!free_look) {
		//camera_pan = move_angle(camera_pan,my.pan,abs(camera_pan-my.pan)/10);	
		if (target_enemy == null) {
			camera_pan -= ang(camera_pan-my.pan)*0.1*time_step; //0.1=speed
			}else{
			vec_diff(temp.x,target_enemy.x,my.x);  /// compute the direction of the enemy from me and save in temp.x/y/z
			vec_to_angle(temp.pan,temp.x);         /// and convert the direction in temp to an angle and store in temp.pan
			camera_pan = temp.pan;
			camera_tilt = temp.tilt;
			camera_tilt = clamp(camera_tilt,-60,60);    // was -30,10

		}
	}

	temp = fcos(camera_tilt,-camera_distance);
	camera_tilt = clamp(camera_tilt,-60,60);    // wasn't clamped originally

	vec_set(camera_move_to.x,vector(my.x + fcos(camera.pan,temp),my.y + fsin(camera.pan,temp),my.z +camera_adjust_z + 20 + fsin(camera_tilt,-camera_distance)));

	temp = min(1,0.5 * time); //changing 0.5 will change how fast the camera moves, at 1 places us at target, this value is what allows the smooth movement
	camera.x += temp*(camera_move_to.x - camera.x);
	camera.y += temp*(camera_move_to.y - camera.y);
	camera.z += temp*(camera_move_to.z - camera.z);

	vec_diff(temp.x,camera.x,my.x);
	vec_normalize(temp.x,16);
	vec_add(temp.x,camera.x);

	c_trace(my.x,temp.x,ignore_me|ignore_passable|ignore_models);
	IF (result > 0) {
		vec_diff(temp.x,my.x,target.x);
		vec_normalize(temp.x,16);
		vec_set(camera.x,target.x);
		vec_add(camera.x,temp.x);
	}

	vec_set(camera_view_to.x,my.x);
	vec_diff(temp.x,my.x,camera.x);
	vec_to_angle(temp.pan,temp.x);
	camera.pan = ang(temp.pan);
	camera.tilt = temp.tilt + 6;
}


// This appears to be the camera code that locks on to an enemy's position and focuses the
// camera on that enemy, no matter how we move ourselves

//////////////////////////////
//Smooth camera collision
//////////////////////////////

FUNCTION handle_lockon_camera() {
	vec_diff(temp.x,target_enemy.x,my.x);  /// compute the direction of the enemy from me and save in temp.x/y/z
	vec_to_angle(temp.pan,temp.x);         /// and convert the direction in temp to an angle and store in temp.pan

	result = ang(temp.pan - camera.pan);   
	result2 = vec_dist(my.x,target_enemy.x) / 10; //how fast the camera spins is based on how far away the player is from the enemy (this stops the camera spinning too fast when the player is further away)
	IF (abs(result) > 120) { result2 /= abs(result)*0.05; } //result2 determines how fast the camera spins around to meet the player, if the angle from the player to the enemy is greater than 120 degrees from the camera's angle then we start speeding up the spinning
	//	result3 = -45 * (((1000 - vec_dist(my.x,target_enemy.x)) / 2500) + 0.6);
	result = temp.pan + (result3 * sign(result));

	vec_set(temp2.x,my.x);
	vec_to_screen(temp2.x,camera);       ///temp2 contains the screen co-ordinates of my ship?? 

	camera_spin_speed = result2;
	temp = ang(result - camera_pan) / (5 + camera_spin_speed); //temp is the speed at which the camera turns, it is based on the angular difference, it also moves to the nearest 45 degres from the player's angle, to offset it a little


	//	IF (ang(my.pan - camera.pan) > 45 || ang(my.pan - camera.pan) < -45) { temp *= vec_dist(my.x,target_enemy.x)/10; }
	temp *= vec_dist(my.x,target_enemy.x)/40;

	IF (camera_pan > result) { result3 = 1; }
	IF (camera_pan < result) { result3 = -1; }
	camera_pan += temp * time_step;
	//	IF (result3 == -1 && camera_pan > result) || (result3 == 1 && camera_pan < result) { camera_pan = result; }

	camera.pan = camera_pan;

	camera_tilt = 0;
	temp = fcos(camera_tilt,-camera_distance);
	vec_set(camera_move_to.x,vector(my.x + fcos(camera.pan,temp),my.y + fsin(camera.pan,temp),my.z + 20 + fsin(camera_tilt,-camera_distance)));

	temp = min(1,0.5 * time); //changing 0.5 will change how fast the camera moves, at 1 places us at target, this value is what allows the smooth movement
	camera.x += temp*(camera_move_to.x - camera.x);
	camera.y += temp*(camera_move_to.y - camera.y);
	camera.z += temp*(camera_move_to.z - camera.z);

	vec_diff(temp.x,camera.x,my.x);
	vec_normalize(temp.x,16);
	vec_add(temp.x,camera.x);

	c_trace(my.x,temp.x,ignore_me|ignore_passable|ignore_models);
	IF (result > 0) {
		vec_diff(temp.x,my.x,target.x);
		vec_normalize(temp.x,16);
		vec_set(camera.x,target.x);
		vec_add(camera.x,temp.x);
	}

	camera_view_to.x = my.x - ((my.x - target_enemy.x) / 2.4);
	camera_view_to.y = my.y - ((my.y - target_enemy.y) / 2.4);
	camera_view_to.z = my.z - ((my.z - target_enemy.z) / 2.4);

	//	camera.pan = move_variable(camera.pan,camera_pan_to.pan,10);
	//	camera.tilt = move_variable(camera.tilt,camera_pan_to.tilt,10);

	//	camera.tilt = camera_tilt;
}





FUNCTION handle_camera() {
	my=player;

	while (1) {
		//			IF (target_enemy == null) {
			//					IF (camera_interpolate_state == on + 1) { camera_interpolate_state = on;	}
			handle_3rd_camera();
			//				} ELSE {
			//					IF (camera_interpolate_state == off) { camera_interpolate_state = on;	}
			//					handle_lockon_camera();
			//			
		//			}
		//		
		handle_camera_rotation();
		wait(1);
	}
}


function free_look_toggle ()
{
	free_look = (!free_look); // toggle the free mouse
	target_enemy = null;
}

on_mouse_right = free_look_toggle;